﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DesignPattern.FactoryMethodPattern.FactoryMethod;

namespace DesignPattern.FactoryMethodPattern.BatchFactory
{
    /// <summary>
    /// 步骤决策者基类(包含创建工厂和数量)
    /// </summary>
    public abstract class Decision
    {
        protected IBatchFactory factory;
        protected int quantity;

        public Decision(IBatchFactory factory, int quantity)
        {
            this.factory = factory;
            this.quantity = quantity;
        }

        public virtual IBatchFactory Factory
        {
            get { return this.factory; }
        }
        public virtual int Quantity
        {
            get { return this.quantity; }
        }
    }
    //具体播放器决策类(此处可以通过配置文件配数量)
    public class RealPlayerDecision : Decision
    {
        public RealPlayerDecision() : base(new BatchRealPlayerFactory(), 3000) { }
    }
    public class MSMediaPlayerDecision : Decision
    {
        public MSMediaPlayerDecision() : base(new BatchMSMediaPlayerFactory(), 2000) { }
    }
}
