﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DesignPattern.FactoryMethodPattern.FactoryMethod
{
    /// <summary>
    /// 支持MS Media Player的视频播放器
    /// </summary>
    public class MSMediaPlayer : VideoPlayer
    {
        public override void StartUp()
        {
            Console.WriteLine("MSMediaPLayer is starting...");
        }
        public override void Play()
        {
            Console.WriteLine("MSMediaPLayer is playing...");
        }
        public override void Pause(int inteval)
        {
            Console.WriteLine("MSMediaPLayer is paused by " + inteval + "minutes.");
        }
        public override void Stop()
        {
            Console.WriteLine("MSMediaPLayer has stopped.");
        }
    }

    /// <summary>
    /// 创建MSMediaPLayer的视频播放器工厂
    /// </summary>
    public class MSMediaPlayerFactory : VideoPlayerFactory
    {
        public MSMediaPlayerFactory() { }
        /*
        public static MSMediaPLayer CreateMSMediaPLayer()
        {
            return new MSMediaPLayer();
        }
        */
        public override VideoPlayer CreateVideoPlayer()
        {
            return new MSMediaPlayer();
        }
    }
}
