﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DesignPattern.FactoryMethodPattern.FactoryMethod
{
    /// <summary>
    /// 支持RealPlayer的视频播放器
    /// </summary>
    public class RealPlayer : VideoPlayer
    {
        public override void StartUp()
        {
            Console.WriteLine("RealPlayer is starting...");
        }
        public override void Play()
        {
            Console.WriteLine("RealPlayer is playing...");
        }
        public override void Pause(int inteval)
        {
            Console.WriteLine("RealPlayer is paused by " + inteval + "minutes.");
        }
        public override void Stop()
        {
            Console.WriteLine("RealPlayer has stopped.");
        }
    }

    /// <summary>
    /// 创建RealPlayer的视频播放器工厂
    /// </summary>
    public class RealPlayerFactory : VideoPlayerFactory
    {
        public RealPlayerFactory() { }
        /*
        public static RealPlayer CreateRealPlayer()
        {
            return new RealPlayer();
        }
        */
        public override VideoPlayer CreateVideoPlayer()
        {
            return new RealPlayer();
        }
    }
}
