﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DesignPattern.FactoryMethodPattern.FactoryMethod
{
    /// <summary>
    /// 泛型视频播放器工厂
    /// </summary>
    public abstract class GenericVideoFactory<T> where T : VideoPlayer, new()
    {
        public virtual T CreateVideoPlayer()
        {
            return new T();
        }
    }
    //视频播放器具体创建工厂
    public class GenericRealPlayerFactory : GenericVideoFactory<RealPlayer> { }
    public class GenericMSMediaPlayerFactory : GenericVideoFactory<MSMediaPlayer> { }
}
