﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data.OracleClient;

namespace DesignPattern.FactoryMethodPattern.SimpleFactory
{
    /// <summary>
    /// 数据库类型枚举
    /// </summary>
    public enum DataBaseType
    {
        SqlServer,
        Oracle
    }
    /// <summary>
    /// 获取数据库提供者工厂
    /// </summary>
    public class DBFactory
    {
        public static DBProvider CreateDBProvider(DataBaseType dbType, string connectionString)
        {
            switch (dbType)
            {
                case DataBaseType.SqlServer:
                default:
                    return new SqlServerProvider(connectionString);
                case DataBaseType.Oracle:
                    return new OracleProvider(connectionString);
            }
        }
    }
}
