﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Common;

namespace DesignPattern.FactoryMethodPattern.SimpleFactory
{
    /// <summary>
    /// 定义数据库提供者基类
    /// </summary>
    public abstract class DBProvider
    {
        protected string connectionString = String.Empty;
        protected DbConnection Connection = null;

        public DBProvider(string connectionString)
        {
            this.connectionString = connectionString;
        }

        public abstract void Connect();
        public abstract bool CheckConect();
        public abstract DataTable ExecuteDataSet(string selectSql);
        public abstract bool ExecuteInsert(string insertSql);
        public abstract bool ExecuteUpdate(string updateSql);
        public abstract bool ExecuteDelete(string deleteSql);
    }
}
