﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace DesignPattern.FactoryMethodPattern.SimpleFactory
{
    /// <summary>
    /// Sql Server提供者实现
    /// </summary>
    public class SqlServerProvider : DBProvider
    {
        public SqlServerProvider(string connectionString)
            : base(connectionString)
        {
            Connection = new SqlConnection(connectionString);
        }

        public override void Connect()
        {
            //SqlServer Connect
        }

        public override bool CheckConect()
        {
            return true;
        }

        public override DataTable ExecuteDataSet(string selectSql)
        {
            return null;
        }

        public override bool ExecuteInsert(string insertSql)
        {
            return true;
        }

        public override bool ExecuteUpdate(string updateSql)
        {
            return true;
        }

        public override bool ExecuteDelete(string deleteSql)
        {
            return true;
        }
    }
}
