﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace DesignPattern.SingletonPattern.Paramerteral
{
    public class Singleton
    {
        //1.保存唯一实例的静态的私有变量
        private static volatile Singleton instance = null;
        private static object lockHelper = new object();
        private string message = String.Empty;
        //2.私有构造函数以防止外部实例化
        private Singleton(string message)
        {
            this.message = message;
        }
        //3.初始化并获得唯一实例的静态属性或方法
        public static Singleton Instance
        {
            get
            {
                //double check操作
                if (instance == null)
                {
                    lock (lockHelper)
                    {
                        if (instance == null)
                        {
                            //var date = DateTime.Now.DayOfWeek == DayOfWeek.Saturday || DateTime.Now.DayOfWeek == DayOfWeek.Sunday;
                            //instance = new Singleton(date ? "weekday" : "workday");
                            var message = ConfigurationManager.AppSettings["SingletonMessage"];
                            instance = new Singleton(message);
                        }
                    }
                }
                return instance;
            }
        }
        public string Message
        {
            get { return this.message; }
        }

        //3.初始化并获得唯一实例的静态属性或方法
        public static Singleton GetInstance(string message)
        {
            //double check操作
            if (instance == null)
            {
                lock (lockHelper)
                {
                    if (instance == null)
                    {
                        instance = new Singleton(message);
                    }
                }
            }
            return instance;
        }
    }
}
