﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DesignPattern.SingletonPattern.SingleThread
{
    public class Singleton
    {
        //1.保存唯一实例的静态的私有变量
        private static Singleton instance;
        //2.私有构造函数以防止外部实例化
        private Singleton()
        {
        }
        //3.初始化并获得唯一实例的静态属性或方法
        public static Singleton Instance
        {
            get
            {
                if (instance == null)
                {
                    instance = new Singleton();
                }
                return instance;
            }
        }
    }
}
