﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using DesignPattern.SingletonPattern.SingletonN;

namespace DesignPattern.UnitTest.Singleton
{
    [TestClass]
    public class SingletonTest
    {
        [TestMethod]
        public void TestSingletonN()
        {
            var c1 = SingletonN.Instance;
            var c2 = SingletonN.Instance;
            var c3 = SingletonN.Instance;
            Assert.IsNull(c3);//c3因为没有空间而无法实例化
            //证明c1,c2是两个不同的实例
            Assert.AreNotEqual<int>(c1.GetHashCode(), c2.GetHashCode());
            c1.DeActivate();//将c1的空间释放掉
            c3 = SingletonN.Instance;//此时因为有了空间,c3可以获得空间实例化
            Assert.IsNotNull(c3);
            c2.DeActivate();
            Assert.IsNotNull(c3);//此时仍然有空间,c3还是存在的
            //c3虽然获得了新的空间,但该空间是属于之前c1或c2释放的
            Assert.IsTrue(c3.GetHashCode() == c1.GetHashCode() || c3.GetHashCode() == c2.GetHashCode());
        }
    }
}
